-- Scorchio! 2
-- A multi-mob vulnerability manager
-- ennui@bloodhoof-eu
-- Email: ennuilg@gmail.com

Scorchio2 = LibStub("AceAddon-3.0"):NewAddon("Scorchio2", "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0", "LibBars-1.0", "LibSink-2.0")
local L = LibStub:GetLibrary("AceLocale-3.0"):GetLocale("Scorchio2")
local SM = LibStub("LibSharedMedia-3.0")
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")

-- Constants for mobTable
local MOBNAME = 1
local REFRESHTIME = 2
local DURATION = 3
local STACK = 4
local CASTS = 5
local TIMER = 6
local BAR = 7

local AFFILIATION = bit.bor(COMBATLOG_OBJECT_AFFILIATION_MINE, COMBATLOG_OBJECT_AFFILIATION_PARTY, COMBATLOG_OBJECT_AFFILIATION_RAID)

-- Register some sounds
SM:Register("sound", "AchievementSound", [[Sound\Spells\AchievmentSound1.wav]])

-- vulnKeys
local T = { "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "o", "o", "o", "o"}
 
-- Spell Constants
local SPELLIDS = {
        { [2948]=true, [8444]=true, [8445]=true, [8446]=true, [10205]=true, [10206]=true, [10207]=true, [27903]=true, [27074]=true, [42858]=true, [42859]=true   }, -- Scorch
        { [116]=true, [205]=true, [837]=true, [7322]=true, [8406]=true, [8407]=true, [8408]=true, [10179]=true, [10180]=true, [10181]=true, [25304]=true, [27071]=true, [27072]=true, [38697]=true, [42841]=true, [42842]=true, -- Frostbolt
          [122]=true, [865]=true, [6131]=true, [10230]=true, [27088]=true, [42917]=true, -- Frost Nova
          [120]=true, [8492]=true, [10159]=true, [10160]=true, [10161]=true, [27087]=true, [42930]=true, [42931]=true, -- Cone of Cold
          [30455]=true, [42913]=true, [42914]=true, -- Ice Lance
          [44614]=true, [47610]=true, -- Frostfire Bolt
          [106]=true, [6141]=true, [8427]=true, [10185]=true, [10186]=true, [10187]=true, [27085]=true, [42939]=true, [42940]=true -- Blizzard
        },
        { --[[ [44461]=true, [55361]=true, [55362]=true --]] }, -- Living Bomb
        { [118]=true, [12824]=true, [12825]=true, [12826]=true, -- Polymorph
          [28271]=true, -- Polymorph: Turtle
          [28272]=true, -- Polymorph: Pig
          [61025]=true, -- Polymorph: Serpent
          [61305]=true, -- Polymorph: Black Cat
		  [61721]=true, -- Polymorph: Rabbit
		  [61780]=true -- Polymorph: Turkey
        },
        { [31589]=true  }, -- Slow
        { }, -- Hot Streak
        { [133]=true, [143]=true, [145]=true, [3140]=true, [8400]=true, [8401]=true, [8402]=true, [10148]=true, [10149]=true, [10150]=true, [10151]=true, [25306]=true, [27070]=true, [38692]=true, [42832]=true, [42833]=true },-- Fireball
        { }, -- Clearcasting
        { [30451]=true, [42894]=true, [42896]=true, [42897]=true }, -- Arcane Blast
        { }, -- Brain Freeze
        { }, -- Fingers of Frost
        { [686]=true, [695]=true, [705]=true, [1088]=true, [1106]=true, [7641]=true, [11659]=true, [11660]=true, [11661]=true, [25307]=true, [27209]=true, [47808]=true, [47809]=true }, -- Shadow Bolt
        { [31687] = true }, -- Summon Water Elemental
        { [55342] = true }, -- Mirror Image
		{ } -- Torment the Weak
    }
    
local VULNERABILITIES = {
        { [22959]=true, -- Improved Scorch
          [38715]=true -- Fire Vulnerability
        },
        { [12579]=true -- Winter's Chill
        },
        { [44457]=true, -- Living Bomb I
          [55359]=true, -- Living Bomb II
          [55360]=true -- Living Bomb III
        },
        { [118]=true, [12824]=true, [12825]=true, [12826]=true, -- Polymorph
          [28271]=true, -- Polymorph: Turtle
          [28272]=true, -- Polymorph: Pig
          [61025]=true, -- Polymorph: Serpent
          [61305]=true, -- Polymorph: Black Cat
		  [61721]=true, -- Polymorph: Rabbit
		  [61780]=true -- Polymorph: Turkey
        },
        { [31589]=true -- Slow
        },
        { [48108]=true -- Hot Streak
        },
        { [44401]=true -- Missile Barrage
        },
        { [12536]=true -- Clearcasting
        },
        { [36032]=true -- Arcane Blast
        },
        { [57761]=true -- Brain Freeze (Fireball!)
        },
        { [44544]=true -- Fingers of Frost
        },
        { [17794]=true, [17797]=true, [17798]=true, [17799]=true, [17800]=true -- Shadow Mastery
        },
        { --[[ [31687] --]]  -- Water Elemental
        },
        { [55342]=true -- Mirror Image
        },
		{ [31589]=true }, -- TtW Slow
		{ [6343]=true, [8198]=true, [8204]=true, [8205]=true, [11580]=true, [11581]=true, [25264]=true, [47501]=true, [47502]=true }, -- TtW Thunderclap
		{ [55095]=true }, -- TtW Frost Fever
		{ [48483]=true, [48484]=true, [48485]=true }, -- TtW Infected Wounds
		{
		  [20184]=true, [20185]=true, [20186]=true -- Paladin Judgements which may be talented with Judgement of the Just
		}
    }
	
local VULNDATA = {
    { -- Scorch
        self = false,
        durationpve = 30,
        durationpvp = 30,
        maxstacks = 5,
        unique = false,
        valid = 4294967295,
		checkPally = false
    },
    { -- Winter's Chill
        self = false,
        durationpve = 15,
        durationpvp = 15,
        maxstacks = 5,
        unique = false,
        valid = 4294967295,
		checkPally = false
    },
    { -- Living Bomb
        self = false,
        durationpve = 12,
        durationpvp = 12,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
		checkPally = false
    },
    { -- Polymorph
        self = false,
        durationpve = 50,
        durationpvp = 10,
        maxstacks = 1,
        unique = true,
        valid = 4294967295,
		checkPally = false
    },
    { -- Slow
        self = false,
        durationpve = 15,
        durationpvp = 10,
        maxstacks = 1,
        unique = true,
        valid = 4294967295,
		checkPally = false
    },
    { -- Hot Streak
        self = true,
        durationpve = 10,
        durationpvp = 10,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
		checkPally = false
	},
    { -- Missile Barrage
        self = true,
        durationpve = 15,
        durationpvp = 15,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
		checkPally = false
	},
    { -- Clearcasting
        self = true,
        durationpve = 15,
        durationpvp = 15,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
		checkPally = false
	},
    { -- Arcane Blast
        self = true,
        durationpve = 10,
        durationpvp = 10,
        maxstacks = 3,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
		checkPally = false
	},
    { -- Brain Freeze
        self = true,
        durationpve = 15,
        durationpvp = 15,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
		checkPally = false
    },
    { -- Fingers of Frost
        self = true,
        durationpve = 15,
        durationpvp = 15,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
		checkPally = false
	},
    {  -- Shadow Mastery
        self = false,
        durationpve = 30,
        durationpvp = 30,
        maxstacks = 1,
        unique = false,
        valid = 4294967295,
		checkPally = false
    },
    {  -- Water Elemental
        self = true,
        durationpve = 45,
        durationpvp = 45,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
		checkPally = false
    },
    {  -- Mirror Image
        self = true,
        durationpve = 30,
        durationpvp = 30,
        maxstacks = 1,
        unique = true,
        valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
		checkPally = false
    },
    { -- TtW Slow
        self = false,
        durationpve = 15,
        durationpvp = 10,
        maxstacks = 1,
        unique = false,
        valid = 4294967295,
		checkPally = false
    },
	{  -- TtW Thunderclap
		self = false,
		durationpve = 30,
		durationpvp = 10,
		maxstacks = 1,
		unique = false,
		valid = 4294967295,
		checkPally = false
	},
	{  -- TtW Frost Fever
		self = false,
		durationpve = 15,
		durationpvp = 10,
		maxstacks = 1,
		unique = false,
		valid = 4294967295,
		checkPally = false
	},
	{  -- TtW Infected Wounds
		self = false,
		durationpve = 12,
		durationpvp = 10,
		maxstacks = 1,
		unique = false,
		valid = 4294967295,
		checkPally = false
	},
	{  -- TtW Pally Judgements
		self = false,
		durationpve = 20,
		durationpvp = 10,
		maxstacks = 1,
		unique = false,
		valid = 4294967295,
		checkPally = true
	}
}
    

-- Utility Functions    
local function Colours(pack, alpha)
    local r, g, b = unpack(pack)
    return r, g, b, alpha
end
Scorchio2.Colours = Colours
    
local function GetSMIndex(t, value)
	for k, v in pairs(SM:List(t)) do
	if v == value then
		return k
		end
	end
	return nil
end
Scorchio2.GetSMIndex = GetSMIndex

local function SubTokens( inputText, mobName, spellCount)
    if mobName ~= nil then
        inputText = string.gsub(inputText, "$m", tostring(mobName))
    end
    if spellCount ~= nil then
        inputText = string.gsub(inputText, "$s", tostring(spellCount))
    end
    return inputText
end
Scorchio2.SubTokens = SubTokens

-- Defaults and Options Tables
local defaults = {
    profile = {
        baroptions = {
            position = { 
                main = { }
            },
            growth = true,
            orientation = 1,
            scale = 1.0,
            fadetime = -1,
            flash = false,
            flashtime = 6,
            iconshow = true,
            iconside = "LEFT",
            raidiconshow = false,
            raidiconpos = -10,
            texture = "Blizzard",
            width = 200,
            height = 18,
            maxbars = 0,
            font = "Arial Narrow",
            fontsize = 12,
            a = {
				message = L["Improved Scorch Expired on $m"],
				warning = L["Rescorch $m!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 6,
                soundson = true,
                warningsound = "Bell",
                expiredsound = "Info",
                bar = "$s x $m",
                fg = { 0, 1, 0 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 0.1,
                focusalpha = 1,
                clearooc = true,
				icon = "Interface\\Icons\\Spell_Fire_SoulBurn"
            },
            b = {
				message = L["Winter's Chill Expired on $m"],
				warning = L["Reapply Winter's Chill on $m!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 5,
                soundson = true,
                bar = "$s x $m",
                warningsound = "Bell",
                expiredsound = "Info",
                fg = { 0, 0, 1 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 0.1,
                focusalpha = 1,	
                clearooc = true,
				icon = "Interface\\Icons\\Spell_Frost_ChillingBlast"
            },
            c = {
				message = L["Living Bomb Exploded on $m"],
				warning = L["$m Is About To Blow!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 0,
                soundson = true,
                bar = "$m",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 1, 0, 0 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 0.1,
                focusalpha = 1,
                clearooc = true,
				icon = "Interface\\Icons\\Ability_Mage_LivingBomb"
            },
            d = {
				message = L["Polymorph Broken on $m"],
				warning = L["Resheep $m!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                telltale = true,
                warningtime = 6,
                soundson = true,
                bar = "$m",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 1, 0, 0.5 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 0.1,
                focusalpha = 1,
                clearooc = true,
				icon = "Interface\\Icons\\Spell_Nature_Polymorph"
            },
            e = {
				message = L["Slow Faded on $m"],
				warning = L["Recast Slow on $m"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 6,
                soundson = true,
                bar = "$m",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 0, 0, 0.5 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 0.1,
                focusalpha = 1,
                clearooc = true,
				icon = "Interface\\Icons\\Spell_Nature_Slow"
            },
            f = {
				apply = L["HOT STREAK!"],
				message = L["Hot Streak Faded"],
				warning = L["Use Hot Streak Soon!"],
                track = true,
                show = true,
                showproc = true,
                showwarning = true,
                showexpire = true,
                warningtime = 3,
                soundson = true,
                bar = L["Hot Streak"],
                procsound = "Ping",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 1, 0.2, 0 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 1,
                focusalpha = 1,
                clearooc = false,
				icon = "Interface\\Icons\\Ability_Mage_HotStreak"
            },
            g = {
				apply = L["MISSILE BARRAGE!"],
				message = L["Missile Barrage Faded"],
				warning = L["Use Missile Barrage Soon!"],
                track = true,
                show = true,
                showproc = true,
                showwarning = true,
                showexpire = true,
                warningtime = 5,
                soundson = true,
                bar = L["Missile Barrage"],
                procsound = "Ping",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 0.4, 0.8, 1 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 1,
                focusalpha = 1,
                clearooc = false,
				icon = "Interface\\Icons\\Ability_Mage_MissileBarrage"
            },
            h = {
				apply = L["CLEARCASTING!"],
				message = L["Clearcasting Faded"],
				warning = L["Use Clearcasting Soon!"],
                track = true,
                show = true,
                showproc = true,
                showwarning = true,
                showexpire = true,
                warningtime = 5,
                soundson = true,
                bar = L["Clearcasting"],
                procsound = "Ping",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 0.4, 1, 0.4 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 1,
                focusalpha = 1,
                clearooc = false,
				icon = "Interface\\Icons\\Spell_Shadow_ManaBurn"
            },
            i = {
				message = L["Arcane Blast Faded"],
				warning = L["Arcane Blast Fading Soon!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 3,
                soundson = true,
                bar = "$s x " .. L["Arcane Blast"],
                procsound = "Ping",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 1, 0.8, 0.4 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 1,
                focusalpha = 1,
                clearooc = false,
				icon = "Interface\\Icons\\Spell_Arcane_Blast"
            },
            j = {
				apply = L["BRAIN FREEZE!"],
				message = L["Brain Freeze Faded"],
				warning = L["Use Fireball Soon!"],
                track = true,
                show = true,
                showproc = true,
                showwarning = true,
                showexpire = true,
                warningtime = 5,
                soundson = true,
                bar = L["Brain Freeze"],
                procsound = "Ping",
                warningsound = "Bell",
                expiredsound = "Info",                
                fg = { 0.2, 0.4, 1 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 1,
                focusalpha = 1,
                clearooc = false,
				icon = "Interface\\Icons\\Ability_Mage_BrainFreeze"
            },
            k = {
				apply = L["FINGERS OF FROST!"],
				message = L["Fingers of Frost Faded!"],
				warning = L["Use Fingers of Frost Soon!"],
                track = true,
                show = true,
                showproc = true,
                showwarning = true,
                showexpire = true,
                warningtime = 5,
                soundson = true,
                bar = L["Fingers of Frost"],
                procsound = "Ping",
                warningsound = "Bell",
                expiredsound = "Info",
                fg = { 0.2, 0.2, 1 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 1,
                focusalpha = 1,
                clearooc = false,
				icon = "Interface\\Icons\\Ability_Mage_Wintersgrasp"
            },
            l = {
				message = L["Shadow Mastery Faded on $m"],
				warning = L["Shadow Mastery is Running Out on $m!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 6,
                soundson = true,
                bar = L["Shadow Mastery"],
                warningsound = "Bell",
                expiredsound = "Info",
                fg = { 0.2, 0, 0.4 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 0.1,
                focusalpha = 1,
                clearooc = true,
				icon = "Interface\\Icons\\Spell_Shadow_Shadowbolt"
            },
            m = {
				message = L["Water Elemental Dead"],
				warning = L["Water Elemental Fading!"],
                track = true,
                show = true,
                showproc = false,
                showwarning = true,
                showexpire = true,
                warningtime = 10,
                soundson = true,
                bar = L["Water Elemental"],
                warningsound = "Bell",
                expiredsound = "Info",
                fg = { 0.2, 1, 1 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 1,
                focusalpha = 1,
                clearooc = false,
				icon = "Interface\\Icons\\Spell_Frost_SummonWaterElemental_2"
            },
            n = {
				message = L["Mirror Image: Full Threat Restored"],
				warning = L["Mirror Image: Threat Reduction Fading Shortly!"],
                track = true,
                show = true,
                showwarning = true,
                showexpire = true,
                warningtime = 5,
                soundson = true,
                bar = L["Mirror Image"],
                warningsound = "Bell",
                expiredsound = "Info",
                fg = { 0.2, 1, 0 },
                bg = { 0.2, 0.2, 0.2 },
                nonfocusalpha = 1,
                focusalpha = 1,
                clearooc = false,
				icon = "Interface\\Icons\\Spell_Magic_LesserInvisibilty"
            },
			o = {
				message = L["Torment the Weak Faded on $m"],
				warning = "",
				track = true,
				show = true,
				showwarning = false,
				showexpire = true,
				warningtime = 0,
				soundson = true,
				bar = L["Torment The Weak on"] .. " $m",
				warningsound = "None",
				expiredsound = "Info",
				fg = { 0, 0, 0 },
				bg = { 0.2, 0.2, 0.2 },
				nonfocusalpha = 0.1,
				focusalpha = 1,
                clearooc = true,
				icon = "Interface\\Icons\\Ability_Mage_TormentoftheWeak"
			}
        },
        sinkoptions = { },
        talentedpallies = { },
        debug = {
            duplicates = false,
            sync = false,
            mob = false,
            code = false,
            timers = false,
            log = false
        },
    },
}

local options = {
    type = 'group',
    args = {
    baroptions = {
            type = 'group',
            name = L["Bar Options"],
            desc = L["Bar Options"],
            args = {
        toggle = {
            type = 'execute',
            name = L["Toggle Anchors"],
            desc = L["Shows/Hides the draggable anchors"],
            func = function()
                Scorchio2:ToggleAnchors()
            end,
        },
        test = {
            type = 'execute',
            name = L["Test"],
            desc = L["Shows test bars"],
            func = function()
                   Scorchio2:RunTest()
            end,
        },
        barwidth = {
            type = 'range',
            name = L["Width"],
            desc = L["Change the width of the bars"],
            order = 120,
            get = function()
                return DB.baroptions.width
            end,
            set = function(info, v)
                DB.baroptions.width = v
                Scorchio2:UpdateAnchors()                   
            end,
            min = 24,
            max = 512,
            step = 8,
        },
        barheight = {
            type = 'range',
            name = L["Height"],
            desc = L["Change the height of the bars"],
            order = 121,
            get = function()
                return DB.baroptions.height
            end,
            set = function(info, v)
                DB.baroptions.height = v
                Scorchio2:UpdateAnchors()
            end,
            min = 6,
            max = 64,
            step = 2,
        },
        scale = {
            type = 'range',
            name = L["Scale"],
            desc = L["Change the scale of the bars"],
            order = 122,
            min = 0.5,
            max = 2,
            get = function()
                return DB.baroptions.scale
            end,
            set = function(info, v)
                DB.baroptions.scale = v
                Scorchio2:UpdateAnchors()
            end
        },
        maxbars = {
            type = 'range',
            name = L["Max Bars"],
            desc = L["Maximum number of bars to show at any one time. Set to 0 to show all bars."],
            order = 123,
            min = 0,
            max = 10,
            step = 1,
            get = function()
            return DB.baroptions.maxbars
            end,
            set = function(info, v)
            DB.baroptions.maxbars = v
            Scorchio2:UpdateAnchors()
            end
        },
        orientation = {
            type = 'select',
            name = L["Orientation"],
            desc = L["Change which way the bars run"],
            order = 124,
            values = { [1]="Left to Right", [3]="Right to Left" },
            get = function()
            return DB.baroptions.orientation
            end,
            set = function(info, v)
            DB.baroptions.orientation = v
            Scorchio2:UpdateAnchors()
            end
        },
        growth = {
            type = 'toggle',
            name = L["Grow Up"],
            desc = L["If checked, bars will stack above the anchor, not below"],
            order = 125,
            get = function()
                return DB.baroptions.growth
            end,
            set = function(info, v)
                DB.baroptions.growth = v
                Scorchio2:UpdateAnchors()
            end
        },
        font = {
            type = 'select',
            name = L["Font"],
            desc = L["Set the bar font"],
            order = 126,
                    values = SM:List("font"),
                    get = function(info)
                        return GetSMIndex("font", DB.baroptions.font)
                    end,
                    set = function(info, v)
                        DB.baroptions.font = SM:List("font")[v]
                        Scorchio2:UpdateAnchors()
                    end,
                },
            fontsize = {
                type = 'range',
                name = L["Font Size"],
                desc = L["Change the font size"],
                order = 127,
                min = 7,
                max = 24,
                step = 1,
                get = function()
                return DB.baroptions.fontsize
                end,
                set = function(info, v)
                DB.baroptions.fontsize = v
                Scorchio2:UpdateAnchors()
                end
            },
            texture = {
                type = 'select',
                    name = L["Texture"],
                    desc = L["Change the texture of the bars"],
                    order = 128,
                    values = SM:List("statusbar"),
                    get = function() 
                        return GetSMIndex("statusbar", DB.baroptions.texture) 
                    end,
                    set = function(info, v)
                        DB.baroptions.texture = SM:List("statusbar")[v]
                        Scorchio2:UpdateAnchors()
                    end,
                },
            a = {
                type = 'group',
                name = L["Scorch"],
                desc = L["Scorch"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Scorch"],
                        desc = L["Track Scorch"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.a.track
                        end,
                        set = function(info, v)
                            DB.baroptions.a.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    },                        
                    show = {
                        type = 'toggle',
                        name = L["Show Scorch Bars"],
                        desc = L["Show Scorch Bars"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.a.track
                        end,
                        get = function()
                            return DB.baroptions.a.show
                        end,
                        set = function(info, v)
                            DB.baroptions.a.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.a.track
                        end,
                        get = function()
                            return DB.baroptions.a.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.a.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Scorch Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.a.track
                        end,
                        get = function()
                            return DB.baroptions.a.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.a.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.a.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.a.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.a.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.a.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.a.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.a.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when spell is about to expire"],
                        order = 125,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.a.track
                        end,
                        get = function()
                            return DB.baroptions.a.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.a.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Scorch"],
                        order = 130,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.a.track
                        end,
                        get = function()
                            return DB.baroptions.a.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.a.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 30,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Improved Scorch will fade."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 135,
                        disabled = function()
                            return not DB.baroptions.a.track
                        end,
                        get = function()
                            return DB.baroptions.a.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.a.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when spell expires"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.a.track
                        end,
                        get = function()
                            return DB.baroptions.a.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.a.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter warning to appear when Improved Scorch expires."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.a.track
                        end,
                        get = function()
                            return DB.baroptions.a.message
                        end,
                        set = function(info, v)
                            DB.baroptions.a.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Scorch"],
                        order = 150,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.a.track
                        end,
                        get = function()
                            return DB.baroptions.a.soundson
                        end,
                        set = function()
                            DB.baroptions.a.soundson = not DB.baroptions.a.soundson
                        end
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order = 155,
                        disabled = function()
                            return not DB.baroptions.a.soundson or not DB.baroptions.a.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.a.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.a.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.a.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the debuff expires"],
                        order = 160,
                        disabled = function()
                            return not DB.baroptions.a.soundson or not DB.baroptions.a.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.a.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.a.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.a.expiredsound))
                        end,
                    },
                },
            },
            b = {
                type = 'group',
                name = L["Winter's Chill"],
                desc = L["Winter's Chill"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Winter's Chill"],
                        desc = L["Track Winter's Chill"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.b.track
                        end,
                        set = function(info, v)
                            DB.baroptions.b.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    }, 
                    show = {
                        type = 'toggle',
                        name = L["Show Winter's Chill Bars"],
                        desc = L["Show Winter's Chill Bars"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.b.track
                        end,
                        get = function()
                            return DB.baroptions.b.show
                        end,
                        set = function(info, v)
                            DB.baroptions.b.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.b.track
                        end,
                        get = function()
                            return DB.baroptions.b.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.b.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Winter's Chill Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.b.track
                        end,
                        get = function()
                            return DB.baroptions.b.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.b.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.b.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.b.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.b.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.b.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.b.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.b.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when spell is about to expire"],
                        order = 125,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.b.track
                        end,
                        get = function()
                            return DB.baroptions.b.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.b.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Winter's Chill"],
                        order = 130,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.b.track
                        end,
                        get = function()
                            return DB.baroptions.b.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.b.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 30,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Winter's Chill will fade."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 135,
                        disabled = function()
                            return not DB.baroptions.b.track
                        end,
                        get = function()
                            return DB.baroptions.b.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.b.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when spell expires"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.b.track
                        end,
                        get = function()
                            return DB.baroptions.b.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.b.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter message to appear when Winter's Chill expires."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.b.track
                        end,
                        get = function()
                            return DB.baroptions.b.message
                        end,
                        set = function(info, v)
                            DB.baroptions.b.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Winter's Chill"],
                        order = 150,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.b.track
                        end,
                        get = function()
                            return DB.baroptions.b.soundson
                        end,
                        set = function()
                            DB.baroptions.b.soundson = not DB.baroptions.b.soundson
                        end
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order = 155,
                        disabled = function()
                            return not DB.baroptions.b.soundson or not DB.baroptions.b.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.b.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.b.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.b.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the debuff expires"],
                        order = 160,
                        disabled = function()
                            return not DB.baroptions.b.soundson or not DB.baroptions.b.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.b.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.b.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.b.expiredsound))
                        end,
                    },
                },
            },
            c = {
                type = 'group',
                name = L["Living Bomb"],
                desc = L["Living Bomb"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Living Bomb"],
                        desc = L["Track Living Bomb"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.c.track
                        end,
                        set = function(info, v)
                            DB.baroptions.c.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    }, 
                    show = {
                        type = 'toggle',
                        name = L["Show Living Bomb Bars"],
                        desc = L["Show Living Bomb Bars"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.c.track
                        end,
                        get = function()
                            return DB.baroptions.c.show
                        end,
                        set = function(info, v)
                            DB.baroptions.c.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.c.track
                        end,
                        get = function()
                            return DB.baroptions.c.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.c.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Living Bomb Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.c.track
                        end,
                        get = function()
                            return DB.baroptions.c.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.c.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 112,
                        disabled = function()
                            return not DB.baroptions.c.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.c.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.c.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 113,
                        disabled = function()
                            return not DB.baroptions.c.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.c.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.c.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when spell is about to expire"],
                        order = 115,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.c.track
                        end,
                        get = function()
                            return DB.baroptions.c.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.c.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },  
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Living Bomb"],
                        order = 120,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.c.track
                        end,
                        get = function()
                            return DB.baroptions.c.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.c.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 12,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Living Bomb is about to go off."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 125,
                        disabled = function()
                            return not DB.baroptions.c.track
                        end,
                        get = function()
                            return DB.baroptions.c.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.c.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when spell expires"],
                        order = 130,
                        disabled = function()
                            return not DB.baroptions.c.track
                        end,
                        get = function()
                            return DB.baroptions.c.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.c.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter message to appear when Living Bomb explodes."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 135,
                        disabled = function()
                            return not DB.baroptions.c.track
                        end,
                        get = function()
                            return DB.baroptions.c.message
                        end,
                        set = function(info, v)
                            DB.baroptions.c.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Living Bomb"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.c.track
                        end,
                        get = function()
                            return DB.baroptions.c.soundson
                        end,
                        set = function()
                            DB.baroptions.c.soundson = not DB.baroptions.c.soundson
                        end
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.c.soundson or not DB.baroptions.c.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.c.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.c.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.c.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the debuff expires"],
                        order = 150,
                        disabled = function()
                            return not DB.baroptions.c.soundson or not DB.baroptions.c.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.c.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.c.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.c.expiredsound))
                        end,
                    }, 
                },
            },
            d = {
                type = 'group',
                name = L["Polymorph"],
                desc = L["Polymorph"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Polymorph"],
                        desc = L["Track Polymorph"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.d.track
                        end,
                        set = function(info, v)
                            DB.baroptions.d.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    }, 
                    show = {
                        type = 'toggle',
                        name = L["Show Polymorph Bars"],
                        desc = L["Show Polymorph Bars"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.d.track
                        end,
                        get = function()
                            return DB.baroptions.d.show
                        end,
                        set = function(info, v)
                            DB.baroptions.d.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.d.track
                        end,
                        get = function()
                            return DB.baroptions.d.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.d.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Polymorph Bars."].. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.d.track
                        end,
                        get = function()
                            return DB.baroptions.d.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.d.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.d.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.d.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.d.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.d.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.d.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.d.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    }, 
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when spell is about to expire"],
                        order = 125,
                        disabled = function()
                            return not DB.baroptions.d.track
                        end,
                        get = function()
                            return DB.baroptions.d.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.d.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    telltale = {
                        type = 'toggle',
                        name = L["Show Who Broke Polymorph"],
                        desc = L["Show Who Broke Polymorph"],
                        order = 127,
                        disabled = function()
                            return not DB.baroptions.d.track
                        end,
                        get = function()
                            return DB.baroptions.d.telltale
                        end,
                        set = function(info, v)
                            DB.baroptions.d.telltale = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Polymorph"],
                        order = 130,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.d.track
                        end,
                        get = function()
                            return DB.baroptions.d.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.d.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 12,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Polymorph is about to break."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 135,
                        disabled = function()
                            return not DB.baroptions.d.track
                        end,
                        get = function()
                            return DB.baroptions.d.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.d.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when spell expires"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.d.track
                        end,
                        get = function()
                            return DB.baroptions.d.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.d.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter message to appear when Polymorph breaks."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.d.track
                        end,
                        get = function()
                            return DB.baroptions.d.message
                        end,
                        set = function(info, v)
                            DB.baroptions.d.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Polymorph"],
                        order = 150,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.d.track
                        end,
                        get = function()
                            return DB.baroptions.d.soundson
                        end,
                        set = function()
                            DB.baroptions.d.soundson = not DB.baroptions.d.soundson
                        end
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order = 155,
                        disabled = function()
                            return not DB.baroptions.d.soundson or not DB.baroptions.d.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.d.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.d.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.d.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the debuff expires"],
                        order = 160,
                        disabled = function()
                            return not DB.baroptions.d.soundson or not DB.baroptions.d.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.d.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.d.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.d.expiredsound))
                        end,
                    },
                },
            },
            e = {
                type = 'group',
                name = L["Slow"],
                desc = L["Slow"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Slow"],
                        desc = L["Track Slow"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.e.track
                        end,
                        set = function(info, v)
                            DB.baroptions.e.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    }, 
                    show = {
                        type = 'toggle',
                        name = L["Show Slow Bars"],
                        desc = L["Show Slow Bars"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.e.track
                        end,
                        get = function()
                            return DB.baroptions.e.show
                        end,
                        set = function(info, v)
                            DB.baroptions.e.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.e.track
                        end,
                        get = function()
                            return DB.baroptions.e.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.e.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Slow Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.e.track
                        end,
                        get = function()
                            return DB.baroptions.e.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.e.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.e.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.e.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.e.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.e.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.e.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.e.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    }, 
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when spell is about to expire"],
                        order = 125,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.e.track
                        end,
                        get = function()
                            return DB.baroptions.e.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.e.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Slow"],
                        order = 130,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.e.track
                        end,
                        get = function()
                            return DB.baroptions.e.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.e.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 12,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Slow is about to expire."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 135,
                        disabled = function()
                            return not DB.baroptions.e.track
                        end,
                        get = function()
                            return DB.baroptions.e.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.e.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when spell expires"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.e.track
                        end,
                        get = function()
                            return DB.baroptions.e.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.e.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter message to appear when Slow expires."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.e.track
                        end,
                        get = function()
                            return DB.baroptions.e.message
                        end,
                        set = function(info, v)
                            DB.baroptions.e.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Slow"],
                        order = 150,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.e.track
                        end,
                        get = function()
                            return DB.baroptions.e.soundson
                        end,
                        set = function()
                            DB.baroptions.e.soundson = not DB.baroptions.e.soundson
                        end
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order =155,
                        disabled = function()
                            return not DB.baroptions.e.soundson or not DB.baroptions.e.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.e.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.e.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.e.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the debuff expires"],
                        order = 160,
                        disabled = function()
                            return not DB.baroptions.e.soundson or not DB.baroptions.e.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.e.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.e.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.e.expiredsound))
                        end,
                    },
                },
            },
            f = {
                type = 'group',
                name = L["Hot Streak"],
                desc = L["Hot Streak"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Hot Streak"],
                        desc = L["Track Hot Streak"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.f.track
                        end,
                        set = function(info, v)
                            DB.baroptions.f.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    }, 
                    show = {
                        type = 'toggle',
                        name = L["Show Hot Streak Bar"],
                        desc = L["Show Hot Streak Bar"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.f.track
                        end,
                        get = function()
                            return DB.baroptions.f.show
                        end,
                        set = function(info, v)
                            DB.baroptions.f.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.f.track
                        end,
                        get = function()
                            return DB.baroptions.f.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.f.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Hot Streak bars."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.f.track
                        end,
                        get = function()
                            return DB.baroptions.f.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.f.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.f.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.f.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.f.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.f.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.f.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.f.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    showproc = {
                        type = 'toggle',
                        name = L["Show Proc"],
                        desc = L["Show message when Hot Streak procs"],
                        order = 125,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.f.track
                        end,
                        get = function()
                            return DB.baroptions.f.showproc
                        end,
                        set = function(info, v)
                            DB.baroptions.f.showproc = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    proctext = {
                        type = 'input',
                        name = L["Proc Text String"],
                        desc = L["Enter message to appear when Hot Streak procs"],
                        width = "full",
                        order = 130,
                        disabled = function()
                            return not DB.baroptions.f.track
                        end,
                        get = function()
                            return DB.baroptions.f.apply
                        end,
                        set = function(info, v)
                            DB.baroptions.f.apply = v
                        end
                    },
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when spell is about to expire"],
                        order = 135,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.f.track
                        end,
                        get = function()
                            return DB.baroptions.f.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.f.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Hot Streak"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.f.track
                        end,
                        get = function()
                            return DB.baroptions.f.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.f.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 12,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Hot Streak is about to fade."],
                        width = "full",
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.f.track
                        end,
                        get = function()
                            return DB.baroptions.f.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.f.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when spell expires"],
                        order = 150,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.f.track
                        end,
                        get = function()
                            return DB.baroptions.f.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.f.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter message to appear when Hot Streak expires."],
                        width = "full",
                        order = 155,
                        disabled = function()
                            return not DB.baroptions.f.track
                        end,
                        get = function()
                            return DB.baroptions.f.message
                        end,
                        set = function(info, v)
                            DB.baroptions.f.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Hot Streak"],
                        order = 160,
                        disabled = function()
                            return not DB.baroptions.f.track
                        end,
                        get = function()
                            return DB.baroptions.f.soundson
                        end,
                        set = function()
                            DB.baroptions.f.soundson = not DB.baroptions.f.soundson
                        end
                    },
                    procsound = {
                        type = 'select',
                        name = L["Proc Sound"],
                        desc = L["Change the sound played when the buff procs"],
                        order = 165,
                        disabled = function()
                            return not DB.baroptions.f.soundson or not DB.baroptions.f.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.f.procsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.f.procsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.f.procsound))
                        end,
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order = 170,
                        disabled = function()
                            return not DB.baroptions.f.soundson or not DB.baroptions.f.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.f.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.f.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.f.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the buff expires"],
                        order = 175,
                        disabled = function()
                            return not DB.baroptions.f.soundson or not DB.baroptions.f.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.f.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.f.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.f.expiredsound))
                        end,
                    },
                },
            },
            g = {
                type = 'group',
                name = L["Missile Barrage"],
                desc = L["Missile Barrage"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Missile Barrage"],
                        desc = L["Track Missile Barrage"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.g.track
                        end,
                        set = function(info, v)
                            DB.baroptions.g.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    }, 
                    show = {
                        type = 'toggle',
                        name = L["Show Missile Barrage Bar"],
                        desc = L["Show Missile Barrage Bar"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.g.track
                        end,
                        get = function()
                            return DB.baroptions.g.show
                        end,
                        set = function(info, v)
                            DB.baroptions.g.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.g.track
                        end,
                        get = function()
                            return DB.baroptions.g.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.g.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Missile Barrage bars."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.g.track
                        end,
                        get = function()
                            return DB.baroptions.g.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.g.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.g.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.g.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.g.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.g.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.g.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.g.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    showproc = {
                        type = 'toggle',
                        name = L["Show Proc"],
                        desc = L["Show message when Missile Barrage procs"],
                        order = 125,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.g.track
                        end,
                        get = function()
                            return DB.baroptions.g.showproc
                        end,
                        set = function(info, v)
                            DB.baroptions.g.showproc = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    proctext = {
                        type = 'input',
                        name = L["Proc Text String"],
                        desc = L["Enter message to appear when Missile Barrage procs"],
                        width = "full",
                        order = 130,
                        disabled = function()
                            return not DB.baroptions.g.track
                        end,
                        get = function()
                            return DB.baroptions.g.apply
                        end,
                        set = function(info, v)
                            DB.baroptions.g.apply = v
                        end
                    },
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when spell is about to expire"],
                        order = 135,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.g.track
                        end,
                        get = function()
                            return DB.baroptions.g.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.g.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Missile Barrage"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.g.track
                        end,
                        get = function()
                            return DB.baroptions.g.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.g.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 12,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Missile Barrage is about to fade."],
                        width = "full",
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.g.track
                        end,
                        get = function()
                            return DB.baroptions.g.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.g.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when spell expires"],
                        order = 150,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.g.track
                        end,
                        get = function()
                            return DB.baroptions.g.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.g.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter message to appear when Missile Barrage expires."],
                        width = "full",
                        order = 155,
                        disabled = function()
                            return not DB.baroptions.g.track
                        end,
                        get = function()
                            return DB.baroptions.g.message
                        end,
                        set = function(info, v)
                            DB.baroptions.g.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Missile Barrage"],
                        order = 160,
                        disabled = function()
                            return not DB.baroptions.g.track
                        end,
                        get = function()
                            return DB.baroptions.g.soundson
                        end,
                        set = function()
                            DB.baroptions.g.soundson = not DB.baroptions.g.soundson
                        end
                    },
                    procsound = {
                        type = 'select',
                        name = L["Proc Sound"],
                        desc = L["Change the sound played when the buff procs"],
                        order = 165,
                        disabled = function()
                            return not DB.baroptions.g.soundson or not DB.baroptions.g.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.g.procsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.g.procsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.g.procsound))
                        end,
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order = 170,
                        disabled = function()
                            return not DB.baroptions.g.soundson or not DB.baroptions.g.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.g.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.g.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.g.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the buff expires"],
                        order = 175,
                        disabled = function()
                            return not DB.baroptions.g.soundson or not DB.baroptions.g.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.g.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.g.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.g.expiredsound))
                        end,
                    },
                },
            },
            h = {
                type = 'group',
                name = L["Clearcasting"],
                desc = L["Clearcasting"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Clearcasting"],
                        desc = L["Track Clearcasting"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.h.track
                        end,
                        set = function(info, v)
                            DB.baroptions.h.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    }, 
                    show = {
                        type = 'toggle',
                        name = L["Show Clearcasting Bar"],
                        desc = L["Show Clearcasting Bar"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.h.track
                        end,
                        get = function()
                            return DB.baroptions.h.show
                        end,
                        set = function(info, v)
                            DB.baroptions.h.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.h.track
                        end,
                        get = function()
                            return DB.baroptions.h.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.h.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Clearcasting bars."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.h.track
                        end,
                        get = function()
                            return DB.baroptions.h.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.h.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.h.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.h.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.h.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.h.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.h.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.h.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    showproc = {
                        type = 'toggle',
                        name = L["Show Proc"],
                        desc = L["Show message when Clearcasting procs"],
                        order = 125,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.h.track
                        end,
                        get = function()
                            return DB.baroptions.h.showproc
                        end,
                        set = function(info, v)
                            DB.baroptions.h.showproc = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    proctext = {
                        type = 'input',
                        name = L["Proc Text String"],
                        desc = L["Enter message to appear when Clearcasting procs"],
                        width = "full",
                        order = 130,
                        disabled = function()
                            return not DB.baroptions.h.track
                        end,
                        get = function()
                            return DB.baroptions.h.apply
                        end,
                        set = function(info, v)
                            DB.baroptions.h.apply = v
                        end
                    },
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when spell is about to expire"],
                        order = 135,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.h.track
                        end,
                        get = function()
                            return DB.baroptions.h.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.h.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Clearcasting"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.h.track
                        end,
                        get = function()
                            return DB.baroptions.h.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.h.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 12,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Clearcasting is about to fade."],
                        width = "full",
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.h.track
                        end,
                        get = function()
                            return DB.baroptions.h.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.h.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when spell expires"],
                        order = 150,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.h.track
                        end,
                        get = function()
                            return DB.baroptions.h.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.h.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter message to appear when Clearcasting expires."],
                        width = "full",
                        order = 155,
                        disabled = function()
                            return not DB.baroptions.h.track
                        end,
                        get = function()
                            return DB.baroptions.h.message
                        end,
                        set = function(info, v)
                            DB.baroptions.h.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Clearcasting"],
                        order = 160,
                        disabled = function()
                            return not DB.baroptions.h.track
                        end,
                        get = function()
                            return DB.baroptions.h.soundson
                        end,
                        set = function()
                            DB.baroptions.h.soundson = not DB.baroptions.h.soundson
                        end
                    },
                    procsound = {
                        type = 'select',
                        name = L["Proc Sound"],
                        desc = L["Change the sound played when the buff procs"],
                        order = 165,
                        disabled = function()
                            return not DB.baroptions.h.soundson or not DB.baroptions.h.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.h.procsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.h.procsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.h.procsound))
                        end,
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order = 170,
                        disabled = function()
                            return not DB.baroptions.h.soundson or not DB.baroptions.h.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.h.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.h.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.h.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the buff expires"],
                        order = 175,
                        disabled = function()
                            return not DB.baroptions.h.soundson or not DB.baroptions.h.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.h.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.h.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.h.expiredsound))
                        end,
                    },
                },
            },
            i = {
                type = 'group',
                name = L["Arcane Blast"],
                desc = L["Arcane Blast"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Arcane Blast"],
                        desc = L["Track Arcane Blast"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.i.track
                        end,
                        set = function(info, v)
                            DB.baroptions.i.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    },                        
                    show = {
                        type = 'toggle',
                        name = L["Show Arcane Blast Bar"],
                        desc = L["Show Arcane Blast Bar"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.i.track
                        end,
                        get = function()
                            return DB.baroptions.i.show
                        end,
                        set = function(info, v)
                            DB.baroptions.i.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.i.track
                        end,
                        get = function()
                            return DB.baroptions.i.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.i.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Arcane Blast Bars."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.i.track
                        end,
                        get = function()
                            return DB.baroptions.i.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.i.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.i.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.i.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.i.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.i.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.i.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.i.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when spell is about to expire"],
                        order = 125,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.i.track
                        end,
                        get = function()
                            return DB.baroptions.i.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.i.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Arcane Blast"],
                        order = 130,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.i.track
                        end,
                        get = function()
                            return DB.baroptions.i.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.i.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 30,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Arcane Blast will fade."],
                        width = "full",
                        order = 135,
                        disabled = function()
                            return not DB.baroptions.i.track
                        end,
                        get = function()
                            return DB.baroptions.i.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.i.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when spell expires"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.i.track
                        end,
                        get = function()
                            return DB.baroptions.i.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.i.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter warning to appear when Arcane Blast expires."],
                        width = "full",
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.i.track
                        end,
                        get = function()
                            return DB.baroptions.i.message
                        end,
                        set = function(info, v)
                            DB.baroptions.i.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Arcane Blast"],
                        order = 150,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.i.track
                        end,
                        get = function()
                            return DB.baroptions.i.soundson
                        end,
                        set = function()
                            DB.baroptions.i.soundson = not DB.baroptions.i.soundson
                        end
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order = 155,
                        disabled = function()
                            return not DB.baroptions.i.soundson or not DB.baroptions.i.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.i.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.i.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.i.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the debuff expires"],
                        order = 160,
                        disabled = function()
                            return not DB.baroptions.i.soundson or not DB.baroptions.i.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.i.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.i.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.i.expiredsound))
                        end,
                    },
                },
            },
            j = {
                type = 'group',
                name = L["Brain Freeze"],
                desc = L["Brain Freeze"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Brain Freeze"],
                        desc = L["Track Brain Freeze"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.j.track
                        end,
                        set = function(info, v)
                            DB.baroptions.j.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    }, 
                    show = {
                        type = 'toggle',
                        name = L["Show Brain Freeze Bar"],
                        desc = L["Show Brain Freeze Bar"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.j.track
                        end,
                        get = function()
                            return DB.baroptions.j.show
                        end,
                        set = function(info, v)
                            DB.baroptions.j.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.j.track
                        end,
                        get = function()
                            return DB.baroptions.j.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.j.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Brain Freeze bars."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.j.track
                        end,
                        get = function()
                            return DB.baroptions.j.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.j.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.j.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.j.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.j.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.j.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.j.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.j.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    showproc = {
                        type = 'toggle',
                        name = L["Show Proc"],
                        desc = L["Show message when Brain Freeze procs"],
                        order = 125,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.j.track
                        end,
                        get = function()
                            return DB.baroptions.j.showproc
                        end,
                        set = function(info, v)
                            DB.baroptions.j.showproc = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    proctext = {
                        type = 'input',
                        name = L["Proc Text String"],
                        desc = L["Enter message to appear when Brain Freeze procs"],
                        width = "full",
                        order = 130,
                        disabled = function()
                            return not DB.baroptions.j.track
                        end,
                        get = function()
                            return DB.baroptions.j.apply
                        end,
                        set = function(info, v)
                            DB.baroptions.j.apply = v
                        end
                    },
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when spell is about to expire"],
                        order = 135,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.j.track
                        end,
                        get = function()
                            return DB.baroptions.j.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.j.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Brain Freeze"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.j.track
                        end,
                        get = function()
                            return DB.baroptions.j.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.j.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 12,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Brain Freeze is about to fade."],
                        width = "full",
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.j.track
                        end,
                        get = function()
                            return DB.baroptions.j.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.j.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when spell expires"],
                        order = 150,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.j.track
                        end,
                        get = function()
                            return DB.baroptions.j.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.j.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter message to appear when Brain Freeze expires."],
                        width = "full",
                        order = 155,
                        disabled = function()
                            return not DB.baroptions.j.track
                        end,
                        get = function()
                            return DB.baroptions.j.message
                        end,
                        set = function(info, v)
                            DB.baroptions.j.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Brain Freeze"],
                        order = 160,
                        disabled = function()
                            return not DB.baroptions.j.track
                        end,
                        get = function()
                            return DB.baroptions.j.soundson
                        end,
                        set = function()
                            DB.baroptions.j.soundson = not DB.baroptions.j.soundson
                        end
                    },
                    procsound = {
                        type = 'select',
                        name = L["Proc Sound"],
                        desc = L["Change the sound played when the buff procs"],
                        order = 165,
                        disabled = function()
                            return not DB.baroptions.j.soundson or not DB.baroptions.j.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.j.procsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.j.procsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.j.procsound))
                        end,
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order = 170,
                        disabled = function()
                            return not DB.baroptions.j.soundson or not DB.baroptions.j.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.j.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.j.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.j.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the buff expires"],
                        order = 175,
                        disabled = function()
                            return not DB.baroptions.j.soundson or not DB.baroptions.j.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.j.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.j.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.j.expiredsound))
                        end,
                    },
                },
            },
            k = {
                type = 'group',
                name = L["Fingers of Frost"],
                desc = L["Fingers of Frost"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Fingers of Frost"],
                        desc = L["Track Fingers of Frost"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.k.track
                        end,
                        set = function(info, v)
                            DB.baroptions.k.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    }, 
                    show = {
                        type = 'toggle',
                        name = L["Show Fingers of Frost Bar"],
                        desc = L["Show Fingers of Frost Bar"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.k.track
                        end,
                        get = function()
                            return DB.baroptions.k.show
                        end,
                        set = function(info, v)
                            DB.baroptions.k.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.k.track
                        end,
                        get = function()
                            return DB.baroptions.k.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.k.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Fingers of Frost bars."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.k.track
                        end,
                        get = function()
                            return DB.baroptions.k.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.k.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.k.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.k.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.k.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.k.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.k.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.k.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    showproc = {
                        type = 'toggle',
                        name = L["Show Proc"],
                        desc = L["Show message when Fingers of Frost procs"],
                        order = 125,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.k.track
                        end,
                        get = function()
                            return DB.baroptions.k.showproc
                        end,
                        set = function(info, v)
                            DB.baroptions.k.showproc = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    proctext = {
                        type = 'input',
                        name = L["Proc Text String"],
                        desc = L["Enter message to appear when Fingers of Frost procs"],
                        width = "full",
                        order = 130,
                        disabled = function()
                            return not DB.baroptions.k.track
                        end,
                        get = function()
                            return DB.baroptions.k.apply
                        end,
                        set = function(info, v)
                            DB.baroptions.k.apply = v
                        end
                    },
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when spell is about to expire"],
                        order = 135,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.k.track
                        end,
                        get = function()
                            return DB.baroptions.k.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.k.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Fingers of Frost"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.k.track
                        end,
                        get = function()
                            return DB.baroptions.k.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.k.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 12,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Fingers of Frost is about to fade."],
                        width = "full",
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.k.track
                        end,
                        get = function()
                            return DB.baroptions.k.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.k.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when spell expires"],
                        order = 150,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.k.track
                        end,
                        get = function()
                            return DB.baroptions.k.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.k.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter message to appear when Fingers of Frost expires."],
                        width = "full",
                        order = 155,
                        disabled = function()
                            return not DB.baroptions.k.track
                        end,
                        get = function()
                            return DB.baroptions.k.message
                        end,
                        set = function(info, v)
                            DB.baroptions.k.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Fingers of Frost"],
                        order = 160,
                        disabled = function()
                            return not DB.baroptions.k.track
                        end,
                        get = function()
                            return DB.baroptions.k.soundson
                        end,
                        set = function()
                            DB.baroptions.k.soundson = not DB.baroptions.k.soundson
                        end
                    },
                    procsound = {
                        type = 'select',
                        name = L["Proc Sound"],
                        desc = L["Change the sound played when the buff procs"],
                        order = 165,
                        disabled = function()
                            return not DB.baroptions.k.soundson or not DB.baroptions.k.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.k.procsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.k.procsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.k.procsound))
                        end,
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order = 170,
                        disabled = function()
                            return not DB.baroptions.k.soundson or not DB.baroptions.k.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.k.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.k.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.k.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the buff expires"],
                        order = 175,
                        disabled = function()
                            return not DB.baroptions.k.soundson or not DB.baroptions.k.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.k.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.k.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.k.expiredsound))
                        end,
                    },
                },
            },
            l = {
                type = 'group',
                name = L["Shadow Mastery"],
                desc = L["Shadow Mastery"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Shadow Mastery"],
                        desc = L["Track Shadow Mastery"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.l.track
                        end,
                        set = function(info, v)
                            DB.baroptions.l.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    },                        
                    show = {
                        type = 'toggle',
                        name = L["Show Shadow Mastery Bars"],
                        desc = L["Show Shadow Mastery Bars"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.l.track
                        end,
                        get = function()
                            return DB.baroptions.l.show
                        end,
                        set = function(info, v)
                            DB.baroptions.l.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.l.track
                        end,
                        get = function()
                            return DB.baroptions.l.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.l.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Shadow Mastery Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.l.track
                        end,
                        get = function()
                            return DB.baroptions.l.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.l.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.l.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.l.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.l.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.l.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.l.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.l.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when spell is about to expire"],
                        order = 125,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.l.track
                        end,
                        get = function()
                            return DB.baroptions.l.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.l.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Shadow Mastery"],
                        order = 130,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.l.track
                        end,
                        get = function()
                            return DB.baroptions.l.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.l.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 30,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Shadow Mastery will fade."],
                        width = "full",
                        order = 135,
                        disabled = function()
                            return not DB.baroptions.l.track
                        end,
                        get = function()
                            return DB.baroptions.l.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.l.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when spell expires"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.l.track
                        end,
                        get = function()
                            return DB.baroptions.l.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.l.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter warning to appear when Shadow Mastery expires."],
                        width = "full",
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.l.track
                        end,
                        get = function()
                            return DB.baroptions.l.message
                        end,
                        set = function(info, v)
                            DB.baroptions.l.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Shadow Mastery"],
                        order = 150,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.l.track
                        end,
                        get = function()
                            return DB.baroptions.l.soundson
                        end,
                        set = function()
                            DB.baroptions.l.soundson = not DB.baroptions.l.soundson
                        end
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order = 155,
                        disabled = function()
                            return not DB.baroptions.l.soundson or not DB.baroptions.l.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.l.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.l.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.l.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the debuff expires"],
                        order = 160,
                        disabled = function()
                            return not DB.baroptions.l.soundson or not DB.baroptions.l.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.l.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.l.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.l.expiredsound))
                        end,
                    },
                },
            },
            m = {
                type = 'group',
                name = L["Water Elemental"],
                desc = L["Water Elemental"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Water Elemental"],
                        desc = L["Track Water Elemental"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.m.track
                        end,
                        set = function(info, v)
                            DB.baroptions.m.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    },                        
                    show = {
                        type = 'toggle',
                        name = L["Show Water Elemental Bar"],
                        desc = L["Show Water Elemental Bar"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.m.track
                        end,
                        get = function()
                            return DB.baroptions.m.show
                        end,
                        set = function(info, v)
                            DB.baroptions.m.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.m.track
                        end,
                        get = function()
                            return DB.baroptions.m.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.m.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Water Elemental Bar."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.m.track
                        end,
                        get = function()
                            return DB.baroptions.m.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.m.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.m.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.m.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.m.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.m.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.m.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.m.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when Water Elemental is about to die"],
                        order = 125,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.m.track
                        end,
                        get = function()
                            return DB.baroptions.m.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.m.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Water Elemental"],
                        order = 130,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.m.track
                        end,
                        get = function()
                            return DB.baroptions.m.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.m.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 30,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Water Elemental is about to die."],
                        width = "full",
                        order = 135,
                        disabled = function()
                            return not DB.baroptions.m.track
                        end,
                        get = function()
                            return DB.baroptions.m.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.m.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when Water Elemental dies"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.m.track
                        end,
                        get = function()
                            return DB.baroptions.m.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.m.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter warning to appear when Water Elemental dies."],
                        width = "full",
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.m.track
                        end,
                        get = function()
                            return DB.baroptions.m.message
                        end,
                        set = function(info, v)
                            DB.baroptions.m.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Water Elemental"],
                        order = 150,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.m.track
                        end,
                        get = function()
                            return DB.baroptions.m.soundson
                        end,
                        set = function()
                            DB.baroptions.m.soundson = not DB.baroptions.m.soundson
                        end
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order = 155,
                        disabled = function()
                            return not DB.baroptions.m.soundson or not DB.baroptions.m.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.m.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.m.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.m.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the Water Elemental dies"],
                        order = 160,
                        disabled = function()
                            return not DB.baroptions.m.soundson or not DB.baroptions.m.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.m.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.m.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.m.expiredsound))
                        end,
                    },
                },
            },
            n = {
                type = 'group',
                name = L["Mirror Image"],
                desc = L["Mirror Image"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Mirror Image"],
                        desc = L["Track Mirror Image"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.n.track
                        end,
                        set = function(info, v)
                            DB.baroptions.n.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    },                        
                    show = {
                        type = 'toggle',
                        name = L["Show Mirror Image Bar"],
                        desc = L["Show Mirror Image Bar"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.n.track
                        end,
                        get = function()
                            return DB.baroptions.n.show
                        end,
                        set = function(info, v)
                            DB.baroptions.n.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.n.track
                        end,
                        get = function()
                            return DB.baroptions.n.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.n.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Mirror Image Bar."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.n.track
                        end,
                        get = function()
                            return DB.baroptions.n.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.n.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.n.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.n.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.n.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.n.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.n.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.n.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    showwarning = {
                        type = 'toggle',
                        name = L["Show Warnings"],
                        desc = L["Show warning when spell is about to expire"],
                        order = 125,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.n.track
                        end,
                        get = function()
                            return DB.baroptions.n.showwarning
                        end,
                        set = function(info, v)
                            DB.baroptions.n.showwarning = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    warningtime = {
                        type = 'range',
                        name = L["Warning Time"],
                        desc = L["Warning Time for Mirror Image"],
                        order = 130,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.n.track
                        end,
                        get = function()
                            return DB.baroptions.n.warningtime
                        end,
                        set = function(info, v)
                            DB.baroptions.n.warningtime = v
                            Scorchio2:UpdateAnchors()                   
                        end,
                        min = 0,
                        max = 30,
                        step = 1,
                    },
                    warningtext = {
                        type = 'input',
                        name = L["Warning Text String"],
                        desc = L["Enter warning to appear when Mirror Image is about to expire."],
                        width = "full",
                        order = 135,
                        disabled = function()
                            return not DB.baroptions.n.track
                        end,
                        get = function()
                            return DB.baroptions.n.warning
                        end,
                        set = function(info, v)
                            DB.baroptions.n.warning = v
                        end
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when spell expires"],
                        order = 140,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.n.track
                        end,
                        get = function()
                            return DB.baroptions.n.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.n.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter warning to appear when Mirror Image expires"],
                        width = "full",
                        order = 145,
                        disabled = function()
                            return not DB.baroptions.n.track
                        end,
                        get = function()
                            return DB.baroptions.n.message
                        end,
                        set = function(info, v)
                            DB.baroptions.n.message = v
                        end
                    },
                    on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Mirror Image"],
                        order = 150,
                        width = "full",
                        disabled = function()
                            return not DB.baroptions.n.track
                        end,
                        get = function()
                            return DB.baroptions.n.soundson
                        end,
                        set = function()
                            DB.baroptions.n.soundson = not DB.baroptions.n.soundson
                        end
                    },
                    warningsound = {
                        type = 'select',
                        name = L["Warning Sound"],
                        desc = L["Change the sound played when warning time is reached"],
                        order = 155,
                        disabled = function()
                            return not DB.baroptions.n.soundson or not DB.baroptions.n.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.n.warningsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.n.warningsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.n.warningsound))
                        end,
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the buff expires"],
                        order = 160,
                        disabled = function()
                            return not DB.baroptions.n.soundson or not DB.baroptions.n.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.n.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.n.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.n.expiredsound))
                        end,
                    },
                },
            },
            o = {
                type = 'group',
                name = L["Torment The Weak"],
                desc = L["Torment The Weak"],
                args = {
                    track = {
                        type = 'toggle',
                        name = L["Track Torment The Weak"],
                        desc = L["Track Torment The Weak"],
                        order = 100,
                        width = "full",
                        get = function()
                            return DB.baroptions.o.track
                        end,
                        set = function(info, v)
                            DB.baroptions.o.track = v
                            Scorchio2:UpdateAnchors()
                        end
                    }, 
                    show = {
                        type = 'toggle',
                        name = L["Show Torment The Weak Bars"],
                        desc = L["Show Torment The Weak Bars"],
                        order = 105,
                        disabled = function()
                            return not DB.baroptions.o.track
                        end,
                        get = function()
                            return DB.baroptions.o.show
                        end,
                        set = function(info, v)
                            DB.baroptions.o.show = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    clearooc = {
                        type = 'toggle',
                        name = L["Fade bars when out of combat"],
                        desc = L["Fade bars when out of combat"],
                        order = 107,
                        disabled = function()
                            return not DB.baroptions.o.track
                        end,
                        get = function()
                            return DB.baroptions.o.clearooc
                        end,
                        set = function(info, v)
                            DB.baroptions.o.clearooc = v
                        end
                    },
                    bartext = {
                        type = 'input',
                        name = L["Bar Text String"],
                        desc = L["Enter text to appear on Torment The Weak Bars."] .. L[" $s will be replaced by the spell stack. $m will be replaced by the mob name. Everything else will remain as-is."],
                        width = "full",
                        order = 110,
                        disabled = function()
                            return not DB.baroptions.o.track
                        end,
                        get = function()
                            return DB.baroptions.o.bar
                        end,
                        set = function(info, v)
                            DB.baroptions.o.bar = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    barcolour = {
                        type = 'color',
                        name = L["Bar Colour"],
                        desc = L["Change bar colour"],
                        order = 115,
                        disabled = function()
                            return not DB.baroptions.o.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.o.fg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.o.fg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    backgroundcolour = {
                        type = 'color',
                        name = L["Background Colour"],
                        desc = L["Change background colour"],
                        order = 120,
                        disabled = function()
                            return not DB.baroptions.o.track
                        end,
                        get = function(info)
                            return unpack(DB.baroptions.o.bg)
                        end,
                        set = function(info, r, g, b)
                            DB.baroptions.o.bg = {r, g, b}
                            Scorchio2:UpdateAnchors()
                        end,
                        hasAlpha = false
                    },
                    showexpire = {
                        type = 'toggle',
                        name = L["Show Expire Notices"],
                        desc = L["Show notice when Torment The Weak expires"],
                        order = 125,
						width = "full",
                        disabled = function()
                            return not DB.baroptions.o.track
                        end,
                        get = function()
                            return DB.baroptions.o.showexpire
                        end,
                        set = function(info, v)
                            DB.baroptions.o.showexpire = v
                            Scorchio2:UpdateAnchors()
                        end
                    },
                    expirytext = {
                        type = 'input',
                        name = L["Expiry Text String"],
                        desc = L["Enter warning to appear when Torment The Weak expires"],
                        width = "full",
                        order = 130,
                        disabled = function()
                            return not DB.baroptions.o.track
                        end,
                        get = function()
                            return DB.baroptions.o.message
                        end,
                        set = function(info, v)
                            DB.baroptions.o.message = v
                        end
                    },
					on = {
                        type = 'toggle',
                        name = L["Toggle Sounds"],
                        desc = L["Enable/Disable sounds for Torment The Weak"],
                        order = 135,
                        disabled = function()
                            return not DB.baroptions.o.track
                        end,
                        get = function()
                            return DB.baroptions.o.soundson
                        end,
                        set = function()
                            DB.baroptions.o.soundson = not DB.baroptions.o.soundson
                        end
                    },
                    expiredsound = {
                        type = 'select',
                        name = L["Expired Sound"],
                        desc = L["Change the sound played when the debuff expires"],
                        order = 140,
                        disabled = function()
                            return not DB.baroptions.o.soundson or not DB.baroptions.o.track
                        end,
                        values = SM:List("sound"),
                        get = function() 
                            return GetSMIndex("sound", DB.baroptions.o.expiredsound)
                        end,
                        set = function(info, v)
                            DB.baroptions.o.expiredsound = SM:List("sound")[v]
                            PlaySoundFile(SM:Fetch("sound", DB.baroptions.o.expiredsound))
                        end,
                    },
					rubric = {
						type = 'description',
						name = "\nAlong with Thunderclap (from Warriors), Frost Fever (from Death Knights), Infected Wounds (from Druids) and Mages' Slow, Paladins can " ..
							"also apply a debuff to a boss which activates Torment the Weak, by taking the talent 'Judgement of the Just' which causes all of their " ..
							"judgements to debuff the boss.\n\nUnfortunately, there is no way to see if a judgement is talented or not, so you will need to ask your Paladin " ..
							"tank if they have this talent (which they should) and if so, add them to this Whitelist by targetting them and clicking the 'Add Paladin' " ..
							"button. You should only ever need to do this once - Scorchio! 2 will remember. If you need to delete a Paladin again, select them in the " ..
							"'Delete' drop-down.\n",
							order = 145,
							width = "full"
						},
					addpally = {
						type = 'execute',
						name = L["Add Paladin"],
						desc = L["Add targeted Paladin to Whitelist"],
						order = 150,
						disabled = function()
                            return not DB.baroptions.o.track
                        end,
						func = function()
							local unitGUID = UnitGUID("target")
							if UnitGUID ~= nil then
								local _, unitClass = UnitClass("target")
								if unitClass == "PALADIN" then
									DB.talentedpallies[unitGUID] = UnitName("target")
									table.sort(DB.talentedpallies)
								end
							end
						end
					},
					deletepally = {
						type = 'select',
						name = "Delete Paladin",
						desc = "Judgement of the Just Talented Paladins",
						order = 155,
						disabled = function()
							return not DB.baroptions.o.soundson or not DB.baroptions.o.track
						end,
						values = function()
							return DB.talentedpallies
						end,
						confirm = true,
						confirmText = "Really delete this Paladin? This can't be undone.",
						get = function(info, v)
							return nil
						end,
						set = function(info, v)
							DB.talentedpallies[v] = nil
						end,
					},
					list = {
						type = 'description',
						name = function()
							local listPallies = ""							
							for k, v in pairs(DB.talentedpallies) do
								listPallies = listPallies .. tostring(v) ..", "
							end
							if listPallies == "" then listPallies = "[Empty].." end
							return "Paladins: " .. string.sub(listPallies, 1, -3)
						end,
						order = 160,
						width = "full"
					},
                },
            },
        },
    },
    output = Scorchio2:GetSinkAce3OptionsDataTable(),
    }, -- closes top level group args
} -- closes options
    

    
-- Add-on Functions
function Scorchio2:OnInitialize()

    self.db = LibStub("AceDB-3.0"):New("Scorchio2DB", defaults, "Default")
	
	DB = Scorchio2.db.profile
    
    AceConfig:RegisterOptionsTable("Scorchio2", options)
	
	self:RegisterChatCommand("scorchio", function() LibStub("AceConfigDialog-3.0"):Open("Scorchio2") end )
	self:RegisterChatCommand("scorchio2", function() LibStub("AceConfigDialog-3.0"):Open("Scorchio2") end )
	local optFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Scorchio2", "Scorchio2")
	options.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	self:SetSinkStorage(self.db.profile.sinkoptions)

	
	self.db.RegisterCallback(self, "OnProfileCopied", "UpdateAnchors")
	self.db.RegisterCallback(self, "OnProfileReset", "UpdateAnchors")	

    SM.RegisterCallback(self, "LibSharedMedia_Registered", "UpdateAnchors")
    SM.RegisterCallback(self, "LibSharedMedia_SetGlobal", "UpdateAnchors")
    
    self:CreateAnchor("main")
    
    lastTargetGUID = "0"
    mobTable = { }
    combatFlag = false
    waterElementalGUID = nil
    
    -- Populate table with localised spellnames as Blizzard won't let us check auras against spellID's...
    localSpellNames = { }
    for k, v in pairs(VULNERABILITIES) do
        for kk, vv in pairs(v) do
            local spellName = GetSpellInfo(kk)
            local insertFlag = true
            for i = 1, table.getn(localSpellNames) do
                if localSpellNames[i] == spellName then insertFlag = false end
            end
            if insertFlag then localSpellNames[spellName] = k end
        end
    end
--~ 	localJudgementNames = { }
--~ 	for k, v in pairs(JUDGEMENTS) do
--~ 		localJudgementNames[GetSpellInfo(k)] = 15
--~ 	end
end

function Scorchio2:OnEnable()
    self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    self:RegisterEvent("PLAYER_REGEN_ENABLED")
    self:RegisterEvent("PLAYER_REGEN_DISABLED")
    self:RegisterEvent("PLAYER_TARGET_CHANGED")
end

function Scorchio2:OnDisable()
	self:UnregisterAllEvents()
end


-- Bar and Anchor Functions
function Scorchio2:CreateAnchor(anchor)
	self[anchor] = self:NewBarGroup(anchor, nil, self.db.profile.baroptions.width, self.db.profile.baroptions.height)
	self[anchor]:ClearAllPoints()
	
	self[anchor].id = anchor
	self[anchor].RegisterCallback(self, "AnchorClicked")
	self[anchor]:HideAnchor()
	self[anchor]:SetSortFunction(Scorchio2.SortBars)
	self:UpdateAnchor(anchor)
end

function Scorchio2:RunTest()
	local icon = select(3, GetSpellInfo(27074)) or nil
	local start = GetTime()
    Scorchio2:UpdateTable("Test1", "Test Mob 1", 1, GetTime(), 5)
    Scorchio2:UpdateTable("Test2", "Test Mob 2", 3, GetTime(), 1)
    Scorchio2:UpdateTable("Test3", "Test Mob 3", 2, GetTime(), 3)
    Scorchio2:UpdateTable("Test4", "Test Mob 4", 4, GetTime(), 1)
end

function Scorchio2:AnchorClicked(callback, group, button)
	self:SavePosition(group.id)
	if button == "RightButton" then
		group:HideAnchor()
		group:Lock()
	end
end
function Scorchio2:ToggleAnchors()
	if self.main.button:IsVisible() then
		self.main:HideAnchor()
		self.main:Lock()
	else
		self.main:ShowAnchor()
		self.main:Unlock()
	end
end

function Scorchio2:SavePosition(anchor)
	local p,_,pr,px,py = self[anchor]:GetPoint()
	self.db.profile.baroptions.position[anchor].p = p
	self.db.profile.baroptions.position[anchor].pr = pr
	self.db.profile.baroptions.position[anchor].px = px
	self.db.profile.baroptions.position[anchor].py = py
end

function Scorchio2:UpdateAnchor(anchor)
	self[anchor]:SetTexture(SM:Fetch("statusbar", self.db.profile.baroptions.texture))
	self[anchor]:SetFont(SM:Fetch("font", self.db.profile.baroptions.font), self.db.profile.baroptions.fontsize)
	self[anchor]:SetWidth(self.db.profile.baroptions.width)
	self[anchor]:SetHeight(self.db.profile.baroptions.height)
	self[anchor]:ReverseGrowth(self.db.profile.baroptions.growth)
    self[anchor]:SetOrientation(self.db.profile.baroptions.orientation)
    if self.db.profile.baroptions.maxbars == 0 then
        self[anchor]:SetMaxBars(nil)
    else
        self[anchor]:SetMaxBars(self.db.profile.baroptions.maxbars)
    end
	self[anchor]:SetFlashPeriod(0)

	if self.db.profile.baroptions.flash then
		self[anchor]:SetFlashPeriod(self.db.profile.baroptions.flashtime)
	end

	if not self.db.profile.baroptions.position[anchor] then self.db.profile.baroptions.position[anchor] = {} end
	if self.db.profile.baroptions.position[anchor].p
       and self.db.profile.baroptions.position[anchor].pr
       and self.db.profile.baroptions.position[anchor].px
       and self.db.profile.baroptions.position[anchor].py then
		self[anchor]:ClearAllPoints()
		self[anchor]:SetPoint(self.db.profile.baroptions.position[anchor].p, UIParent, self.db.profile.baroptions.position[anchor].pr, self.db.profile.baroptions.position[anchor].px, self.db.profile.baroptions.position[anchor].py)
		else
			self[anchor]:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
		end
end

function Scorchio2:UpdateAnchors()
	self:UpdateAnchor("main")
end

function Scorchio2.SortBars(a, b)
	if a.isTimer ~= b.isTimer then
		return a.isTimer
	end
	
	if a.maxValue == b.maxValue then
		if a.value == b.value then
			return a.name > b.name
		else
			return a.value > b.value
		end
	else
		return a.maxValue > b.maxValue
	end
end


-- Event Handling Functions

function Scorchio2:WaterElementalLifeSpan()
    local playerClass, englishClass = UnitClass("player")
    if englishClass ~= "MAGE" then return 0 end
    local _, _, _, _, currRank, _ = GetTalentInfo(3,26)
    return 45 + (currRank * 5)
end

function Scorchio2:inCombat()
    if combatFlag then return true end
    if InCombatLockdown("player") then return true end
    return false
end

function Scorchio2:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
    local _, _, prefix, suffix = string.find(event, "(.-)_(.+)")

    local timeStamp = GetTime()
    
	if (prefix == "SPELL") then
		local spellID, spellName, spellSchool, spellAuraType, spellCount, fvApplied
		local spellCount = -1
		local spellID = arg9
		local isPlayer = false
		if bit.band(dstFlags, COMBATLOG_OBJECT_TYPE_PLAYER) == COMBATLOG_OBJECT_TYPE_PLAYER then
		    isPlayer = true
		end
		if (suffix == "CAST_START") then
		    if Scorchio2:inCombat() then return end
		    for k, v in pairs(SPELLIDS) do
                if v[spellID] then
                    if bit.band(srcFlags, AFFILIATION) ~= 0 then
                    Scorchio2:PLAYER_REGEN_DISABLED()
                    end
                end
		    end
		elseif (suffix == "CAST_FAILED") then
		    if InCombatLockdown("player") then return end
		    Scorchio2:PLAYER_REGEN_ENABLED()
		end
        
        if (suffix == "AURA_REMOVED") then	
		    spellCount = -1
		    self:CheckVuln(arg9, spellCount, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)
        end
        
        if (suffix == "SUMMON") then
            if spellID == 31687 and bit.band(srcFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) ~= 0 and DB.baroptions.m.track then
                waterElementalGUID = dstGUID
                self:UpdateTable(waterElementalGUID, dstName, 13, timeStamp, 1, false, self:WaterElementalLifeSpan())
            elseif spellID == 58833 and bit.band(srcFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) ~= 0 and DB.baroptions.n.track then
                self:UpdateTable(srcGUID, srcName, 14, timeStamp, 1, true, 30)
            end
        end
        
		if not Scorchio2:inCombat() then return end
		
		if (suffix == "AURA_APPLIED") then
		    spellCount = 1
		    self:CheckVuln(arg9, spellCount, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)
		elseif (suffix == "AURA_APPLIED_DOSE") then
		    self:CheckVuln(arg9, arg13, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)
		elseif (suffix == "AURA_REFRESH") then
		    self:CheckVuln(arg9, nil, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)

		elseif (suffix == "AURA_REMOVED_DOSE") then						
		    self:CheckVuln(arg9, arg13, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)			
		elseif (suffix == "AURA_BROKEN_SPELL") then
		    self:AuraBroken(dstGUID, srcName, arg13)
		elseif (suffix == "AURA_BROKEN") then
		    self:AuraBroken(dstGUID, srcName, L["Hitting It!"])
		end
	elseif (prefix == "UNIT") then
        if dstGUID == waterElementalGUID then
            self:LostVuln(waterElementalGUID, 13)
            self:MobDies(waterElementalGUID, dstName)
            waterElementalGUID = nil
        elseif dstName ~= nil and mobTable[dstGUID] ~= nil then
			self:MobDies(dstGUID, dstName)
		end
	end
end

function Scorchio2:PLAYER_REGEN_ENABLED()
    combatFlag = false
    for k, v in pairs(mobTable) do
        for kk = 1,table.getn(T) do
            if DB.baroptions[T[kk]].clearooc then
                if mobTable[k][T[kk]] then
                    if mobTable[k][T[kk]][BAR] then
                        mobTable[k][T[kk]][BAR]:Fade(0.5)
                        Scorchio2:ReleaseBar(mobTable[k][T[kk]][BAR])
                    end
                    if mobTable[k][T[kk]][TIMER] then
                        Scorchio2:CancelTimer(mobTable[k][T[kk]][TIMER], true)
                    end
                    mobTable[k][T[kk]] = nil
                end
            end
        end
    end
    lastTargetGUID = "0"
end

function Scorchio2:PLAYER_REGEN_DISABLED()
    combatFlag = true
    Scorchio2:ScanAuras("target")
end

function Scorchio2:PLAYER_TARGET_CHANGED()
    if mobTable[lastTargetGUID] then
        for k = 1,table.getn(T) do
            if mobTable[lastTargetGUID][T[k]] then
                if mobTable[lastTargetGUID][T[k]][BAR] then
                    mobTable[lastTargetGUID][T[k]][BAR].texture:SetVertexColor(Colours(DB.baroptions[T[k]].fg, DB.baroptions[T[k]].nonfocusalpha))
                    mobTable[lastTargetGUID][T[k]][BAR].bgtexture:SetVertexColor(Colours(DB.baroptions[T[k]].bg, DB.baroptions[T[k]].nonfocusalpha))    
                end
            end
        end
    end
    if UnitExists("target") then
		lastTargetGUID = UnitGUID("target")
        for k = 1,table.getn(T) do
            if mobTable[lastTargetGUID] then
                if mobTable[lastTargetGUID][T[k]] then
                    if mobTable[lastTargetGUID][T[k]][BAR] then
                        mobTable[lastTargetGUID][T[k]][BAR].texture:SetVertexColor(Colours(DB.baroptions[T[k]].fg, DB.baroptions[T[k]].focusalpha))
                        mobTable[lastTargetGUID][T[k]][BAR].bgtexture:SetVertexColor(Colours(DB.baroptions[T[k]].bg, DB.baroptions[T[k]].focusalpha))    
                    end
                end
            end
        end
        Scorchio2:ScanAuras("target")
	else
		lastTargetGUID = "0"
	end
end

-- mobTable Handling Functions
function Scorchio2:MobDies(dstGUID, dstName)
    for k = 1,table.getn(T) do
        if mobTable[dstGUID][T[k]] then
            if mobTable[dstGUID][T[k]][BAR] then
                mobTable[dstGUID][T[k]][BAR]:Fade(0.5)
                Scorchio2:ReleaseBar(mobTable[dstGUID][T[k]][BAR])
            end
            if mobTable[dstGUID][T[k]][TIMER] then
                Scorchio2:CancelTimer(mobTable[dstGUID][T[k]][TIMER], true) 
            end
        end
    end
    mobTable[dstGUID] = nil
--~     raidIconTable[self:GetGUID(fullMobName)] = nil
--~     self:UnregisterEnniBarWithGroup(fullMobName,SB)
--~     self:UnregisterEnniBar(fullMobName)
end

function Scorchio2:CheckVuln(spellID, spellCount, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)
    for k, v in pairs(VULNERABILITIES) do
        if v[spellID] then
            if VULNDATA[k].self then
                if bit.band(dstFlags, VULNDATA[k].valid) ~= 0 and DB.baroptions[T[k]].track then
                    self:UpdateTable(dstGUID, dstName, k, timeStamp, spellCount, isPlayer)
                end
            else
                if bit.band(srcFlags, VULNDATA[k].valid) ~= 0 and DB.baroptions[T[k]].track then
					if VULNDATA[k].checkPally == false or (VULNDATA[k].checkPally == true and DB.talentedpallies[srcGUID] ~= nil) then
						self:ScanAuras("target")
						self:UpdateTable(dstGUID, dstName, k, timeStamp, spellCount, isPlayer)
					end
                end
            end
        end
    end
end

function Scorchio2:AuraBroken(dstGUID, srcName, cause)
    if dstGUID then
        if mobTable[dstGUID] then
            if mobTable[dstGUID][T[4]] and DB.baroptions.d.telltale then
                self:Pour(L["Polymorph broken on "] .. tostring(mobTable[dstGUID][T[4]][MOBNAME]) .. L[" by "] .. srcName .. " (" .. tostring(cause) .. ")", 1, 1, 1)
            end
        end
    end
end 
    
function Scorchio2:LostVuln(dstGUID, vulnKey)
	if mobTable[dstGUID][T[vulnKey]][BAR] then
        mobTable[dstGUID][T[vulnKey]][BAR]:Fade(0.5)
        Scorchio2:ReleaseBar(mobTable[dstGUID][T[vulnKey]][BAR])
    end
    if mobTable[dstGUID][T[vulnKey]][TIMER] then
        Scorchio2:CancelTimer(mobTable[dstGUID][T[vulnKey]][TIMER], true)
    end
    
    if Scorchio2:inCombat() or not DB.baroptions[T[vulnKey]].clearooc then
        if (GetTime() - mobTable[dstGUID][T[vulnKey]][REFRESHTIME] > ( mobTable[dstGUID][T[vulnKey]][DURATION] - 0.25 )) or (dstGUID == waterElementalGUID) then
            if DB.baroptions[T[vulnKey]].soundson then
                PlaySoundFile(SM:Fetch("sound", DB.baroptions[T[vulnKey]].expiredsound))
            end
            if DB.baroptions[T[vulnKey]].showexpire then
                self:Pour(SubTokens(DB.baroptions[T[vulnKey]].message, mobTable[dstGUID][T[vulnKey]][MOBNAME]), 1, 0, 0)
            end
        end
    end

    mobTable[dstGUID][T[vulnKey]] = nil
end

function Scorchio2:TimerComplete(info)
    local dstGUID, vulnKey = info[1], info[2]
	local timerTime = GetTime()
    if mobTable[dstGUID][T[vulnKey]] then
		if math.floor((timerTime - mobTable[dstGUID][T[vulnKey]][REFRESHTIME]) + 0.5) >= (mobTable[dstGUID][T[vulnKey]][DURATION] - DB.baroptions[T[vulnKey]].warningtime) then
			if DB.baroptions[T[vulnKey]].soundson then
				PlaySoundFile(SM:Fetch("sound", DB.baroptions[T[vulnKey]].warningsound))
			end
			self:Pour(SubTokens(DB.baroptions[T[vulnKey]].warning, mobTable[dstGUID][T[vulnKey]][MOBNAME]), 1, 0.647, 0)
		end
	end
end


function Scorchio2:ScanAuras(unitID)
    if not UnitExists(unitID) then return end
    if not Scorchio2:inCombat() then return end
    local dstGUID = UnitGUID(unitID)
    local dstName = UnitName(unitID)
    local isPlayer = UnitIsPlayer(unitID)
    if isPlayer == nil then isPlayer = false end
    for i = 1, 40 do
        local name, _, _, count, _, duration, expirationTime, unitCaster, _ = UnitDebuff(unitID, i)
        for k, v in pairs(localSpellNames) do
            if k == name and DB.baroptions[T[v]].track then
				if (VULNDATA[v].valid == COMBATLOG_OBJECT_AFFILIATION_MINE and unitCaster == "player") or VULNDATA[v].valid ~= COMBATLOG_OBJECT_AFFILIATION_MINE then
					if VULNDATA[v].checkPally == false then 
						Scorchio2:UpdateTable(dstGUID, dstName, v, GetTime(), count, isPlayer, expirationTime - GetTime())
					elseif unitCaster ~= nil then
						if DB.talentedpallies[UnitGUID(unitCaster)] ~= nil then
							Scorchio2:UpdateTable(dstGUID, dstName, v, GetTime(), count, isPlayer, expirationTime - GetTime())
						end
					end
				end
            end
        end
    end    
end    

function Scorchio2:UpdateTable(dstGUID, dstName, vulnKey, timeStamp, spellCount, isPlayer, timeToRun)
	if mobTable[dstGUID] == nil then
        mobTable[dstGUID] = { }
    end
    if mobTable[dstGUID][T[vulnKey]] == nil then
        mobTable[dstGUID][T[vulnKey]] = {dstName, timeStamp, 0, 0, nil }
        if DB.baroptions[T[vulnKey]].soundson then
            PlaySoundFile(SM:Fetch("sound", DB.baroptions[T[vulnKey]].procsound))
        end
        if DB.baroptions[T[vulnKey]].showproc then 
            self:Pour(DB.baroptions[T[vulnKey]].apply, 1, 0, 0)
        end    
    end
    if spellCount == nil then spellCount = mobTable[dstGUID][T[vulnKey]][STACK] + 1 end
    if spellCount > VULNDATA[vulnKey].maxstacks then spellCount = VULNDATA[vulnKey].maxstacks end
    if spellCount < 0 then
        self:LostVuln(dstGUID, vulnKey)
    else
        local warningTime = DB.baroptions[T[vulnKey]].warningtime
        local icon = DB.baroptions[T[vulnKey]].icon
        if isPlayer == true then
            duration = VULNDATA[vulnKey].durationpvp
        else
            duration = VULNDATA[vulnKey].durationpve
        end
        local alpha = DB.baroptions[T[vulnKey]].focusalpha
        mobTable[dstGUID][T[vulnKey]][STACK] = spellCount
        mobTable[dstGUID][T[vulnKey]][REFRESHTIME] = timeStamp
        
        if tostring(dstGUID) == UnitGUID("target") then
            lastTargetGUID = dstGUID
        else
            alpha = DB.baroptions[T[vulnKey]].nonfocusalpha
        end

        if timeToRun == nil then
            timeToRun = duration - (GetTime() - timeStamp)
        end
        mobTable[dstGUID][T[vulnKey]][DURATION] = timeToRun
		if mobTable[dstGUID][T[vulnKey]][BAR] then
			if mobTable[dstGUID][T[vulnKey]][BAR].value > timeToRun then
				return
			end
		end
        
        if DB.baroptions[T[vulnKey]].show then
            if VULNDATA[vulnKey].unique then
               for k, v in pairs(mobTable) do
                    if mobTable[k][T[vulnKey]] then
                        if mobTable[k][T[vulnKey]][BAR] then
                            mobTable[k][T[vulnKey]][BAR]:Fade(0.5)
                            Scorchio2:ReleaseBar(mobTable[k][T[vulnKey]][BAR])
                        end
                        if mobTable[k][T[vulnKey]][TIMER] then
                            Scorchio2:CancelTimer(mobTable[k][T[vulnKey]][TIMER], true)
                        end
                    end
                end
            end
            
			local barText = SubTokens(DB.baroptions[T[vulnKey]].bar, dstName, spellCount)

			mobTable[dstGUID][T[vulnKey]][BAR] = Scorchio2.main:NewTimerBar(tostring(dstGUID .. "_" .. T[vulnKey]), barText, timeToRun, duration, icon)

			mobTable[dstGUID][T[vulnKey]][BAR].texture:SetVertexColor(Colours(DB.baroptions[T[vulnKey]].fg, alpha))
			mobTable[dstGUID][T[vulnKey]][BAR].bgtexture:SetVertexColor(Colours(DB.baroptions[T[vulnKey]].bg, alpha))
        end
        
        if warningTime > 0 and DB.baroptions[T[vulnKey]].showwarning then
            if mobTable[dstGUID][T[vulnKey]][TIMER] ~= nil then
                Scorchio2:CancelTimer(mobTable[dstGUID][T[vulnKey]][TIMER], true)
            end
            mobTable[dstGUID][T[vulnKey]][TIMER] = Scorchio2:ScheduleTimer("TimerComplete", (timeToRun - warningTime), { dstGUID , vulnKey })
        end
    end
end